/**********************************************************************
 *
 * fileutil.cpp -- 
 * Copyright (C) 1999  The New Zealand Digital Library Project
 *
 * PUT COPYRIGHT NOTICE HERE
 *
 * $Id: fileutil.cpp 100 1999-01-08 02:33:16Z rjmcnab $
 *
 *********************************************************************/

/*
   $Log$
   Revision 1.3  1999/01/08 02:33:14  rjmcnab

   Added standard header to source files.

 */

static char *RCSID = "$Id: fileutil.cpp 100 1999-01-08 02:33:16Z rjmcnab $";


#include "fileutil.h"


#ifdef __GNUG__
#  include <iostream.h>
#  include <fstream.h>
#else
#  ifndef USE_OBJECTSPACE
#    include <iostream>
#    include <fstream>
#  else
#    include <ospace\std\iostream>
#    include <ospace\std\fstream>
#  endif
#endif


// returns the proper concatenation of the two paths
text_t filename_cat (text_t path1, text_t path2) {
  text_t::iterator here;
  text_t::iterator begin;
  text_t::iterator end;

  // make sure there is just one slash, of the correct type,
  // at the end of path1 (unless path1 is an empty string).
  if (!path1.empty()) {
    // remove all trailing slashes
    here = path1.end();
    here--;
    begin = path1.begin();
    while (here != begin && (*here == '/' || *here == '\\')) {
      here--;
    }
    here++;
    path1.erase(here,path1.end());

    // add one final slash
#ifdef __WIN32__
    path1 += "\\";
#else
    path1 += "/";
#endif 
  }

  // remove all slashes from the start of path2
  here = path2.begin();
  end = path2.end();
  while (here != end && (*here == '/' || *here == '\\')) {
    here++;
  }
  path2.erase (path2.begin(), here);
  
  // return the concatenation of the two strings
  return path1 + path2;
}


// returns true if filename can be opened
bool file_exists (const text_t &filename) {
  char *cstr = filename.getcstr();
  ifstream filestream (cstr);
  delete cstr;

  if (filestream) {
    // file exists
    filestream.close ();
    return true;
  }

  // file does not exist
  return false;
}
