/**********************************************************************
 *
 * cgiargs.cpp -- 
 * Copyright (C) 1999  The New Zealand Digital Library Project
 *
 * PUT COPYRIGHT NOTICE HERE
 *
 * $Id: cgiargs.cpp 108 1999-01-08 08:41:38Z rjmcnab $
 *
 *********************************************************************/

/*
   $Log$
   Revision 1.1  1999/01/08 08:40:54  rjmcnab

   Moved from lib directory.

   Revision 1.1  1999/01/08 07:50:30  rjmcnab

   Moved from src/library directory to lib directory.

 */

static char *RCSID = "$Id: cgiargs.cpp 108 1999-01-08 08:41:38Z rjmcnab $";


#include "cgiargs.h"
#include "gsdlunicode.h"

  
// constructors
cgiargsclass::cgiargsclass ()
{
}


// this returns NULL if there isn't an entry with a value of
// 'key' already defined

void cgiargsclass::setarg (const text_t &key, const text_t &value)
{
  args[key] = value;
}

void cgiargsclass::setdefaultarg (const text_t &key, const text_t &value)
{
  if (getarg(key) == NULL) setarg (key, value);
}

void cgiargsclass::setintarg (const text_t &key, int value)
{
  setarg (key, value);
}

void cgiargsclass::setdefaultintarg (const text_t &key, int value)
{
  if (getarg(key) == NULL) setintarg (key, value);
}

void cgiargsclass::setcarg (const text_t &key, unsigned short c)
{
  text_t t; 
  t.push_back(c);
  setarg(key,t);
}

void cgiargsclass::setdefaultcarg (const text_t &key, unsigned short c)
{
  if (getarg(key) == NULL) setcarg (key, c);
}

text_t *cgiargsclass::getarg (const text_t &key)
{
  iterator here = args.find (key);
  if (here == args.end()) return NULL;

  return &((*here).second);
}

int cgiargsclass::getintarg (const text_t &key)
{
  text_t *text = getarg (key);
  if (text == NULL) return 0;
  return text->getint();
}



// stream operators to print cgi arguments for debugging purposes
ostream &operator<<(ostream &outs, const cgiargsclass &args)
{
  utf8outconvertclass text_t2utf8;
  cgiargsclass::const_iterator here = args.begin ();
  cgiargsclass::const_iterator end = args.end ();

  outs << "*** cgiargsclass\n";
  
  while (here != end)
    {
      outs << text_t2utf8 << " \"" << (*here).first << "\"=\"" << 
	(*here).second << "\"\n";
      here++;
    }
  outs << "\n";

  return outs;
}


